diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
index 3e16b341e..e35788124 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
@@ -17,17 +17,52 @@ import net.minecraft.core.util.phys.HitResult;
 
 import java.util.Random;
 
-public class HudComponentHealthBar
-    extends HudComponentMovable {
+public class HudComponentHealthBar extends HudComponentMovable {
     private final Random random = new Random();
 
     public HudComponentHealthBar(String key, Layout layout) {
-        super(key, 81, 10, layout);
+        super(key, 81, 9, layout);
+    }
+
+    private boolean isVertical() {
+        return GameSettings.VERTICAL_HEALTH_BAR.value;
+    }
+
+    private boolean isFlipped() {
+        return GameSettings.FLIP_HEALTH_BAR.value;
+    }
+
+    @Override
+    public int getDisplayedXSize() {
+        return this.isVertical() ? super.getDisplayedYSize() : super.getDisplayedXSize();
+    }
+
+    @Override
+    public int getDisplayedYSize() {
+        return this.isVertical() ? super.getDisplayedXSize() : super.getDisplayedYSize();
+    }
+
+    @Override
+    public int getTrueXSize() {
+        return this.isVertical() ? super.getTrueYSize() : super.getTrueXSize();
+    }
+
+    @Override
+    public int getTrueYSize() {
+        return this.isVertical() ? super.getTrueXSize() : super.getTrueYSize();
     }
 
     @Override
     public boolean isVisible() {
-        return !mc.thePlayer.getGamemode().hasInvulnerablePlayer() && GameSettings.IMMERSIVE_MODE.drawHotbar();
+        if (mc.thePlayer == null) {
+            return GameSettings.IMMERSIVE_MODE.drawHotbar();
+        }
+        return !mc.thePlayer.getGamemode().hasInvulnerablePlayer() && GameSettings.IMMERSIVE_MODE.drawHotbar() && !GameSettings.HIDE_HEALTH_BAR.value;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return GameSettings.HIDE_HEALTH_BAR.value;
     }
 
     @Override
@@ -36,49 +71,76 @@ public class HudComponentHealthBar
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         // Setup rendering
-        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
         GLRenderer.enableState(State.BLEND);
 
         boolean heartsFlash = (mc.thePlayer.heartsFlashTime / 3) % 2 == 1;
         if (mc.thePlayer.heartsFlashTime < 10) {
             heartsFlash = false;
         }
+
         int health = mc.thePlayer.getHealth();
         int prevHealth = mc.thePlayer.prevHealth;
         this.random.setSeed(hud.updateCounter * 0x4c627L);
         boolean isHardcore = mc.thePlayer.getGamemode() == Gamemodes.HARDCORE;
 
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+        
+        String styleFolder = isHardcore ? "hardcore/" : "survival/";
+        
+        String halfSuffix = "";
+        if (isVertical) {
+            halfSuffix = isFlipped ? "_vertical_flipped" : "_vertical";
+        } else if (isFlipped) {
+            halfSuffix = "_flipped";
+        }
+
         for (int i = 0; i < 10; i++) {
             int heartOffset = 0;
             if (heartsFlash) {
                 heartOffset = 1;
             }
-            int xHeart = x + i * 8;
-            int yHeart = y;
-            if (health <= 4) {
-                yHeart += this.random.nextInt(2);
-            }
 
+            int xHeart;
+            int yHeart;
+
+            // Coordinate logic applying both vertical and flipped states
+            if (isVertical) {
+                xHeart = x;
+                yHeart = isFlipped ? (y + i * 8) : (y + (9 - i) * 8); 
+                if (health <= 4) {
+                    xHeart += this.random.nextInt(2);  // Shake horizontally
+                }
+            } else {
+                xHeart = isFlipped ? (x + (9 - i) * 8) : (x + i * 8); 
+                yHeart = y;
+                if (health <= 4) {
+                    yHeart += this.random.nextInt(2); // Shake vertically
+                }
+            }
+            
             hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/container_blinking"));
+
+            // Flashing Damage/Heal Overlay
             if (heartsFlash) {
                 if (i * 2 + 1 < prevHealth) {
-                    // Half flash heart icon
-                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full_blinking"));
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "full_blinking"));
                 }
                 if (i * 2 + 1 == prevHealth) {
-                    // Full flash heart icon
-                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half_blinking"));
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "half_blinking" + halfSuffix));
                 }
             }
+
+            // Base Health
             if (i * 2 + 1 < health) {
-                // Full heart icon
-                hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full"));
+                hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "full"));
             }
             if (i * 2 + 1 == health) {
-                // Half heart icon
-                hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half"));
+                hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "half" + halfSuffix));
             }
 
+            // Food Regen Overlay
             if (GameSettings.FOOD_HEALTH_REGEN_OVERLAY.value) {
                 int healing = 0;
                 ItemStack held = mc.thePlayer.getHeldItem();
@@ -94,14 +156,15 @@ public class HudComponentHealthBar
                         healing = edible.getHealAmount(mc.currentWorld, hitTile.tilePos);
                     }
                 }
+
                 if (healing > 0) {
                     if (i * 2 + 1 >= health) {
                         if (i * 2 + 1 == health) {
-                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half_right"));
+                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/half_right" + halfSuffix));
                         } else if (i * 2 + 1 < health + healing) {
-                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_full"));
+                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/full"));
                         } else if (i * 2 + 1 == health + healing) {
-                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half"));
+                            hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "preview/half" + halfSuffix));
                         }
                     }
                 }
@@ -114,22 +177,44 @@ public class HudComponentHealthBar
         int x = layout.getComponentX(this, xSizeScreen);
         int y = layout.getComponentY(this, ySizeScreen);
 
-        // Setup rendering
-        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        renderTranslucency();
         GLRenderer.enableState(State.BLEND);
 
         int health = 11;
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
+        String styleFolder = "survival/";
+
+        String halfSuffix = "";
+        if (isVertical) {
+            halfSuffix = isFlipped ? "_vertical_flipped" : "_vertical";
+        } else if (isFlipped) {
+            halfSuffix = "_flipped";
+        }
+
         for (int i = 0; i < 10; i++) {
-            int xHeart = x + i * 8;
-            gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
+            int xHeart;
+            int yHeart;
+
+            if (isVertical) {
+                xHeart = x;
+                yHeart = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xHeart = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yHeart = y;
+            }
+
+            // Container 
+            gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
+
             if (i * 2 + 1 < health) {
-                // Full heart icon
-                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/full"));
+                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "full"));
             }
             if (i * 2 + 1 == health) {
-                // Half heart icon
-                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/half"));
+                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + styleFolder + "half" + halfSuffix));
             }
         }
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
index a451c5703..caf04efd0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.ScreenHudEditor;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.option.Option;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -15,93 +15,178 @@ import net.minecraft.core.util.helper.LightIndexHelper;
 
 import java.awt.Color;
 
-public class HudComponentHeldItemCount
-    extends HudComponentMovable {
+public class HudComponentHeldItemCount extends HudComponentMovable {
     private static final ItemStack PREVIEW_ITEM = new ItemStack(Blocks.COBBLE_BASALT, 53);
+    private static final int ICON_SIZE = 16;
+    private static final int TEXT_HEIGHT = 8;
+    private static final int GAP = 2;
+    private static final int PADDING = 3;
 
     public HudComponentHeldItemCount(String key, Layout layout) {
-        super(key, 53, 22, layout);
+        super(key, 24, 24, layout);
+    }
+
+    private boolean isVertical() {
+        return GameSettings.VERTICAL_HELD_ITEM_COUNT.value;
+    }
+
+    private boolean isFlipped() {
+        return GameSettings.FLIP_HELD_ITEM_COUNT.value;
+    }
+
+    private String getDisplayText() {
+        if (mc.currentScreen instanceof ScreenHudEditor) {
+            return String.valueOf(PREVIEW_ITEM.stackSize);
+        }
+
+        if (mc.thePlayer == null) {
+            return String.valueOf(PREVIEW_ITEM.stackSize);
+        }
+
+        ItemStack heldItemStack = mc.thePlayer.inventory.getCurrentItem();
+        if (heldItemStack == null) return null;
+
+        if (heldItemStack.isItemStackDamageable()) {
+            int remainingDurability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) + 1;
+            return String.valueOf(remainingDurability);
+        } else {
+            int itemCount = 0;
+            int stackCount = 0;
+            for (int i = 0; i < mc.thePlayer.inventory.getContainerSize(); i++) {
+                ItemStack itemStack = mc.thePlayer.inventory.getItem(i);
+                if (itemStack != null && itemStack.itemID == heldItemStack.itemID && itemStack.getMetadata() == heldItemStack.getMetadata()) {
+                    itemCount += itemStack.stackSize;
+                    stackCount++;
+                }
+            }
+            if (stackCount >= 1) {
+                return String.valueOf(itemCount);
+            }
+            return null;
+        }
     }
 
     @Override
-    public boolean isVisible() {
-        return GameSettings.IMMERSIVE_MODE.drawOverlays() && GameSettings.HELD_ITEM_COUNT_OVERLAY.value;
+    public int getDisplayedXSize() {
+        String text = getDisplayText();
+        if (text == null) return 0;
+
+        int textWidth = mc.font.stringWidth(text);
+
+        if (this.isVertical()) {
+            return PADDING * 2 + Math.max(ICON_SIZE, textWidth);
+        } else {
+            return PADDING * 2 + ICON_SIZE + GAP + textWidth;
+        }
     }
 
     @Override
-    public boolean isPreviewTranslucent() {
-        return !GameSettings.HELD_ITEM_COUNT_OVERLAY.value;
+    public int getDisplayedYSize() {
+        String text = getDisplayText();
+        if (text == null) return 0;
+
+        if (this.isVertical()) {
+            return PADDING * 2 + ICON_SIZE + GAP + TEXT_HEIGHT;
+        } else {
+            return PADDING * 2 + Math.max(ICON_SIZE, TEXT_HEIGHT);
+        }
     }
 
     @Override
-    public Option<?> getAttachedOption() {
-        return GameSettings.HELD_ITEM_COUNT_OVERLAY;
+    public int getTrueXSize() {
+        return getDisplayedXSize();
     }
 
     @Override
-    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        int x = this.getLayout().getComponentX(this, xSizeScreen);
-        int y = this.getLayout().getComponentY(this, ySizeScreen);
+    public int getTrueYSize() {
+        return getDisplayedYSize();
+    }
 
-        int xx = x + 3;
-        int yy = y + 3;
+    @Override
+    public boolean isVisible() {
+        return GameSettings.IMMERSIVE_MODE.drawOverlays() && !GameSettings.HIDE_HELD_ITEM_COUNT.value;
+    }
 
-        ItemStack heldItemStack = mc.thePlayer.inventory.getCurrentItem();
-        if (heldItemStack != null) {
-            boolean renderItem;
+    @Override
+    public boolean isPreviewTranslucent() {
+        return GameSettings.HIDE_HELD_ITEM_COUNT.value;
+    }
 
-            if (heldItemStack.isItemStackDamageable()) {
-                renderItem = true;
-                float durability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) / (float) heldItemStack.getMaxDamage();
+    private void drawComponent(int x, int y, ItemStack itemStack, String text, float partialTick) {
+        if (itemStack == null || text == null) return;
 
-                final int color = 0xFF000000 + Color.HSBtoRGB(durability / 3F, 1f, 1f);
-                int remainingDurability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) + 1;
-                mc.font.render(remainingDurability, xx + 18, yy + 4).setShadow().setColor(color).call();
-            } else {
-                int itemCount = 0;
-                int stackCount = 0;
-                for (int i = 0; i < mc.thePlayer.inventory.getContainerSize(); i++) {
-                    ItemStack itemStack = mc.thePlayer.inventory.getItem(i);
-                    if (itemStack != null && itemStack.itemID == heldItemStack.itemID && itemStack.getMetadata() == heldItemStack.getMetadata()) {
-                        itemCount += itemStack.stackSize;
-                        stackCount++;
-                    }
-                }
-                renderItem = stackCount >= 1;
+        int textWidth = mc.font.stringWidth(text);
+        int xx, yy, tx, ty;
 
-                if (renderItem) {
-                    mc.font.render(itemCount, xx + 18, yy + 4).setShadow().setColor(0xFFFFFFFF).call();
-                }
+        if (this.isVertical()) {
+            int maxWidth = Math.max(ICON_SIZE, textWidth);
+            if (this.isFlipped()) {
+                // Flipped Vertical
+                tx = x + PADDING + (maxWidth - textWidth) / 2;
+                ty = y + PADDING;
+                xx = x + PADDING + (maxWidth - ICON_SIZE) / 2;
+                yy = ty + TEXT_HEIGHT + GAP;
+            } else {
+                // Default Vertical
+                xx = x + PADDING + (maxWidth - ICON_SIZE) / 2;
+                yy = y + PADDING;
+                tx = x + PADDING + (maxWidth - textWidth) / 2;
+                ty = yy + ICON_SIZE + GAP;
             }
-
-            if (renderItem) {
-                GLRenderer.enableState(State.DEPTH_TEST);
-                GLRenderer.disableState(State.BLEND);
-                Lighting.enableInventoryLight();
-                ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(GLRenderer.getTessellator(), null, heldItemStack, xx, yy, LightIndexHelper.lightIndex2i(15, 15), partialTick);
-                Lighting.disable();
+        } else {
+            if (this.isFlipped()) {
+                // Flipped Horizontal
+                tx = x + PADDING;
+                ty = y + PADDING + (ICON_SIZE - TEXT_HEIGHT) / 2;
+                xx = tx + textWidth + GAP;
+                yy = y + PADDING;
+            } else {
+                // Default Horizontal
+                xx = x + PADDING;
+                yy = y + PADDING;
+                tx = xx + ICON_SIZE + GAP;
+                ty = y + PADDING + (ICON_SIZE - TEXT_HEIGHT) / 2;
             }
         }
+
+        int color = 0xFFFFFFFF;
+        if (itemStack.isItemStackDamageable()) {
+            float durability = (itemStack.getMaxDamage() - itemStack.getMetadata()) / (float) itemStack.getMaxDamage();
+            color = 0xFF000000 + Color.HSBtoRGB(durability / 3F, 1f, 1f);
+        }
+        mc.font.render(text, tx, ty).setShadow().setColor(color).call();
+
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.disableState(State.BLEND);
+        Lighting.enableInventoryLight();
+        ItemModelDispatcher.getInstance().getDispatch(itemStack).renderGui(GLRenderer.getTessellator(), null, itemStack, xx, yy, LightIndexHelper.lightIndex2i(15, 15), partialTick);
+        Lighting.disable();
+
+        GLRenderer.disableState(State.DEPTH_TEST);
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        if (mc.thePlayer == null) return;
+
+        String text = getDisplayText();
+        ItemStack heldItemStack = mc.thePlayer.inventory.getCurrentItem();
+
+        if (heldItemStack != null && text != null) {
+            int x = this.getLayout().getComponentX(this, xSizeScreen);
+            int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+            drawComponent(x, y, heldItemStack, text, partialTick);
+        }
     }
 
     @Override
     public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
         renderTranslucency();
+        String text = String.valueOf(PREVIEW_ITEM.stackSize);
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
-        int xx = x + 3;
-        int yy = y + 3;
-
-        ItemStack heldItemStack = PREVIEW_ITEM;
-        int itemCount = heldItemStack.stackSize;
-
-        mc.font.render(itemCount, xx + 18, yy + 4).setShadow().setColor(0xFFFFFFFF).call();
-
-        GLRenderer.enableState(State.DEPTH_TEST);
-        GLRenderer.disableState(State.BLEND);
-        Lighting.enableInventoryLight();
-        ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(GLRenderer.getTessellator(), null, heldItemStack, xx, yy, LightIndexHelper.lightIndex2i(15, 15), 0.0f);
-        Lighting.disable();
+        drawComponent(x, y, PREVIEW_ITEM, text, 0.0f);
     }
-}
+}
\ No newline at end of file
